*DECK FLUGPI
      SUBROUTINE FLUGPI(IPRINT,ITYPEC,ISADJ ,ICOPAR,EPSPAR,COPTIO,
     >                  ILEAK ,INITFL,INITLK,IRSDIR,BRSDIR,CARLST)
C
C---------------------------  FLUGPI  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : FLUGPI
C       USE      : READ DATA FOR FLUX SOLUTION MODULE
C       MODIFIED : MODIFY DEFINITION OF ITYPEC
C                  2000/01/27  (G. MARLEAU)
C                  2000/01/20  (T. COURAU, G. MARLEAU)
C                  1994/07/21  (I. PETROVIC, G. MARLEAU)
C                  1991/03/15  (G. MARLEAU)
C                  1991/01/28  (A. HEBERT)
C                  1986/05/14  (G. MARLEAU)
C
C   2- ROUTINE PARAMETERS:
C    INPUT/OUTPUT
C      IPRINT  : PRINT SELECTION FOR FLU MODULE:          I
C               = 0/1/2/3 NO PRINT/SHORT PRINT/LONG
C      ITYPEC  : TYPE OF FLUX EVALUATION                  I
C                = 0  SKIP THE FLUX CALCULATION
C                = 1  DIRECT PROBLEM FISSION SOURCES/
C                     K EFFECTIVE CONVERGENCE
C                = 2  DIRECT PROBLEM FISSION SOURCES/
C                     K EFFECTIVE CONVERGENCE/
C                     FIXED DB2 BUCKLING
C                = 3  DIRECT PROBLEM FISSION SOURCES/
C                     K EFFECTIVE CONVERGENCE/
C                     FIXED B2 BUCKLING
C                     D EVALUATION
C                = 4  DIRECT PROBLEM FISSION SOURCES/
C                     DB2 BUCKLING CONVERGENCE
C                = 5  DIRECT PROBLEM DB2 SOURCES
C                = 6  DIRECT PROBLEM FIXED SOURCES
C      ISADJ   : ADJOINT CALCULATION AND SAVE OPTION      I
C                = 0 ONLY DIRECT FLUX
C                = 1 DIRECT AND PSEUDO ADJOINT FLUX
C                = 2 DIRECT, PSEUDO-ADJOINT AND ADJOINT
C                = 3 DIRECT, PSEUDO ADJOINT AND
C                    GENERALIZED PSEUDO-ADJOINT
C                = 4 DIRECT, PSEUDO ADJOINT, ADJOINT,
C                    GENERALIZED PSEUDO-ADJOINT AND
C                    GENERALIZED ADJOINT
C      ICOPAR  : ITERATION PARAMETERS                     I(6)
C                IFRITR=ICOPAR(1)
C                IACITR=ICOPAR(2)
C                IREBAL=ICOPAR(3)
C                MAXINR=ICOPAR(4)
C                MAXOUT=ICOPAR(5)
C                ICONTM=ICOPAR(6)
C      EPSPAR  : ITERATION PRECISION                      R(NBEPS)
C                EPSINR=EPSPAR(1)
C                EPSOUT=EPSPAR(2)
C                EPSUNK=EPSPAR(3)
C                EPSGPA=EPSPAR(4)
C                CONGPA=EPSPAR(5)
C      COPTIO  : LEAKAGE TYPE                             C*4
C                'LKRD' (IMPOSED LEAKAGE ), 'B0' (B-0),
C                'P0' (P-0), 'B1' (B-1), 'P1' (P-1)
C                'B0TR' (B-0 WITH TRANSPORT CORRECTION).
C                COPTIO='B0' IS DEFAULT FOR TYPE B AND L
C      ILEAK   : METHOD USED TO INCLUDE LEAKAGE EFFECT    I
C                = 0 NO DB2 EFFECT (DEFAULT FOR TYPE S AND K)
C                = 1 HOMOGENEOUS METHOD WITH SCATTERING MODIFIED
C                    CP MATRIX MULTIPLIED BY A PNL FACTOR
C                = 2 HOMOGENEOUS METHOD REDUCED CP MATRIX
C                    MULTIPLIED BY PNL FACTOR
C                    (DEFAULT FOR TYPE B AND L)
C                = 3 HOMOGENEOUS METHOD SIGS0-DB2 APPROXIMATION
C                = 4 HOMOGENEOUS METHOD ALBEDO APPROXIMATION
C                = 5,6,7,8,9,10 HETEROGENEOUS METHOD WITH PIJK
C                  AND FIXED B->5 OR SEARCH X->6 Y->7 Z->8
C                  R->9 ALL->10
C      INITFL  : FLUX INITIALIZATION OPTION               I
C                = 0 DEFAULT INITIALIZATION
C                = 1 READ FROM INPUT AND STROE IN FLXUNK
C                = 2 TAKEN FROM DATA STRUCTURE
C      INITLK  : LEAKAGE INITIALIZATION                   I
C                = 0 NONE
C                = 1 INITIALIZE B2 AND COMPUTE D
C                = 2 INITIALIZE B2 AND D
C      IRSDIR  : BUCKLING DIRECTION READ                  I(NSDIR)
C      BRSDIR  : BUCKLING VALUE READ                      D(NSDIR)
C      CARLST  : LAST CHARACTER READ                      C*4
C---------------------------   FLUGPI  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     NBUCKN,NLEAK,NSDIR,NBEPS,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (NBUCKN=5,NLEAK=5,NSDIR=6,NBEPS=5,
     >            ILCMUP=1,ILCMDN=2,NAMSBR='FLUGPI')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPRINT,ITYPEC,ISADJ,ILEAK,INITFL,INITLK
      CHARACTER   COPTIO*4,CARLST*4
      INTEGER     ICOPAR(6),IRSDIR(NSDIR)
      REAL        EPSPAR(NBEPS)
      DOUBLE PRECISION BRSDIR(NSDIR)
C----
C  INPUT PARAMETERS
C----
      INTEGER     ITYPLU,INTLIR
      CHARACTER   CARLIR*4
      REAL        REALIR
      DOUBLE PRECISION DBLLIR
C----
C  LOCAL PARAMETERS
C----
      INTEGER     ISDIR,JBUC,JLEA,JDIR,IRD
C----
C  DATA
C----
      CHARACTER   CBUCKN(0:NBUCKN)*4,CLEAK(NLEAK)*4,
     >            CSDIR(NSDIR)*4
      SAVE        CBUCKN,CLEAK,CSDIR
      DATA       (CBUCKN(JBUC),JBUC=0,NBUCKN)
     >           /'LKRD','B0','P0','B1','P1','B0TR'/
      DATA       (CLEAK(JLEA),JLEA=1,NLEAK)
     >           /'PNLR','PNL ','SIGS','ALBS','HETE'/
      DATA       (CSDIR(JDIR),JDIR=1,NSDIR)
     >           /'X','Y','Z','R','G','K'/
C----
C  READ OPTION NAME
C----
      ISDIR=0
      IF(CARLST .NE. '    ') THEN
        CARLIR=CARLST
        ITYPLU=3
        GO TO 1010 
      ENDIF
 1000 CONTINUE
      CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
 1010 CONTINUE
      IF(ITYPLU .EQ. 10) THEN
        CARLIR=';'
        GO TO 2000
      ENDIF
      IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >': READ ERROR - CHARACTER VARIABLE EXPECTED')
      IF(CARLIR .EQ. ';') THEN
        GO TO 2000
      ELSE IF(CARLIR .EQ. 'EDIT') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >  ': READ ERROR - EDIT LEVEL EXPECTED')
        IPRINT=INTLIR
      ELSE IF(CARLIR .EQ. 'TYPE') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - TYPE EXPECTED')
        IF(CARLIR .EQ. 'N') THEN
          ITYPEC=0
        ELSE IF(CARLIR .EQ. 'K') THEN
          ITYPEC=1
          ISDIR=6
        ELSE IF(CARLIR .EQ. 'B') THEN
          ITYPEC=4
          ILEAK=2
          ISDIR=5
        ELSE IF(CARLIR .EQ. 'L') THEN
          ITYPEC=5
          ILEAK=2
          ISDIR=5
        ELSE IF(CARLIR .EQ. 'S') THEN
          ITYPEC=6
        ELSE
          CALL XABORT(NAMSBR//
     >    ': INVALID TYPE KEYWORD= '//CARLIR)
        ENDIF
        IF(ITYPEC .GT. 0 .AND. ITYPEC .LT. 6) THEN
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >    ': READ ERROR - BUCKLING OPTION OR KEYWORD EXPECTED')
          DO 100 JBUC=0,NBUCKN
            IF(CARLIR .EQ. CBUCKN(JBUC)) THEN
              COPTIO=CARLIR
              GO TO 105
            ENDIF
 100      CONTINUE
          GO TO 1010
 105      CONTINUE
          IF(ITYPEC .EQ. 1) THEN
            ITYPEC=2
          ENDIF
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//'
     >    : READ ERROR - LEAKAGE TYPE OR KEYWORD EXPECTED')
          DO 110 JLEA=1,NLEAK
            IF(CARLIR .EQ. CLEAK(JLEA)) THEN
              ILEAK=JLEA
              IF(ILEAK .EQ. 5) THEN
                CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
                IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >          ': READ ERROR - DIRECTION OR KEYWORD EXPECTED')
                DO 111 JDIR=1,NSDIR-1
                  IF(CARLIR .EQ. CSDIR(JDIR)) THEN
                    ISDIR=JDIR
                    GO TO 1000
                  ENDIF
 111            CONTINUE
                GO TO 1010
              ENDIF
              GO TO 1000
            ENDIF
 110      CONTINUE
          GO TO 1010
        ENDIF
      ELSE IF(CARLIR .EQ. 'REBA') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - REBALANCING OPTION EXPECTED')
        IF(CARLIR .EQ. 'OFF ') THEN
          ICOPAR(3)=0
        ELSE IF(CARLIR .EQ. 'ON ') THEN
          ICOPAR(3)=1 
        ELSE
          ICOPAR(3)=1 
          GO TO 1010
        ENDIF
      ELSE IF(CARLIR .EQ. 'INIT') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - FLUX INITIALIZATION OPTION REQUIRED')
        IF(CARLIR .EQ. 'OFF ') THEN
          INITFL=0
        ELSE IF(CARLIR .EQ. 'ON  ') THEN
          INITFL=1
          CARLIR='INIT'
          GO TO 2000
        ENDIF
      ELSE IF(CARLIR .EQ. 'THER') THEN
        DO 120 IRD=1,2
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .EQ. 3) THEN
            GO TO 1010
          ELSE IF(ITYPLU .EQ. 1) THEN
            ICOPAR(4)=INTLIR
          ELSE IF(ITYPLU .EQ. 2) THEN
            EPSPAR(1)=REALIR
          ENDIF
 120    CONTINUE
      ELSE IF(CARLIR .EQ. 'EXTE') THEN
        DO 130 IRD=1,2
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .EQ. 3) THEN
            GO TO 1010
          ELSE IF(ITYPLU .EQ. 1) THEN
            ICOPAR(5)=INTLIR
          ELSE IF(ITYPLU .EQ. 2) THEN
            EPSPAR(2)=REALIR
          ENDIF
 130    CONTINUE
      ELSE IF(CARLIR .EQ. 'UNKT') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 2) CALL XABORT(NAMSBR//
     >  ': REAL VALUE OF EPSUNK MUST FOLLOW UNKT')
        EPSPAR(3)=REALIR
      ELSE IF(CARLIR .EQ. 'EGPA') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 2) CALL XABORT(NAMSBR//
     >  ': REAL VALUE OF EGPA REQUIRED')
        EPSPAR(4)=REALIR
      ELSE IF(CARLIR .EQ. 'CGPA') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 2) CALL XABORT(NAMSBR//
     >  ': REAL VALUE OF CGPA REQUIRED')
        EPSPAR(5)=REALIR
      ELSE IF(CARLIR .EQ. 'DECO') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - DECONTAMINATION OPTION EXPECTED')
        IF(CARLIR .EQ. 'OFF ') THEN
          ICOPAR(6)=0
        ELSE IF(CARLIR .EQ. 'ON ') THEN
          ICOPAR(6)=1 
        ELSE
          ICOPAR(6)=1 
          GO TO 1010
        ENDIF
      ELSE IF(CARLIR .EQ. 'ACCE') THEN
        DO 140 IRD=1,2
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >   ': READ ERROR - ACCELERATION PARAMETER MISSING')
          ICOPAR(IRD)=INTLIR
 140    CONTINUE
      ELSE IF(CARLIR .EQ. 'KEFF') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        JDIR=6
        IF(ITYPLU .EQ. 2) THEN
          BRSDIR(JDIR)=DBLE(REALIR)
          IRSDIR(JDIR)=1
        ELSE IF(ITYPLU .EQ. 4) THEN
          BRSDIR(JDIR)=DBLLIR
          IRSDIR(JDIR)=1
        ELSE
          CALL XABORT(NAMSBR//': READ ERROR - KEFF VALUE EXPECTED')
        ENDIF
      ELSE IF(CARLIR .EQ. 'BUCK') THEN 
        JDIR=5
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .EQ. 2) THEN
          BRSDIR(JDIR)=DBLE(REALIR)
          IRSDIR(JDIR)=1
          GO TO 1000
        ELSE IF(ITYPLU .EQ. 4) THEN
          BRSDIR(JDIR)=DBLLIR
          IRSDIR(JDIR)=1
          GO TO 1000
        ELSE IF(ITYPLU .EQ. 1) THEN
          CALL XABORT(NAMSBR//': READ ERROR - BUCK INFO EXPECTED')
        ENDIF
 150    CONTINUE
          DO 160 JDIR=1,NSDIR-1
            IF(CARLIR .EQ. CSDIR(JDIR)) THEN
              CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
              IF(ITYPLU .EQ. 2) THEN
                BRSDIR(JDIR)=DBLE(REALIR)
                IRSDIR(JDIR)=1
                GO TO 165
              ELSE IF(ITYPLU .EQ. 4) THEN
                BRSDIR(JDIR)=DBLLIR
                IRSDIR(JDIR)=1
                GO TO 165
              ELSE
                CALL XABORT(NAMSBR//
     >          ': READ ERROR - DIRECTIONAL BUCKLING EXPECTED')
              ENDIF
            ENDIF
 160      CONTINUE
          GO TO 1010
 165      CONTINUE
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >    ': READ ERROR - BUCKLING DIRECTION OR KEYWORD EXPECTED')
        GO TO 150
      ELSE IF(CARLIR .EQ. 'IDEM') THEN
        IRSDIR(5)=1
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - IDEM TYPE EXPECTED')
        IF(CARLIR .EQ. 'B2') THEN
          INITLK=1
        ELSE IF(CARLIR .EQ. 'DB2') THEN
          INITLK=2
        ELSE
          INITLK=1
          GO TO 1010
        ENDIF
      ELSE IF(CARLIR .EQ. 'FLX') THEN
        ISADJ=0
      ELSE IF(CARLIR .EQ. 'PAF') THEN
        ISADJ=1
      ELSE IF(CARLIR .EQ. 'AF') THEN
        ISADJ=2
C----
C FOLLOWING OPTIONS ARE NOT AVAILABLE
C----
C      ELSE IF(CARLIR .EQ. 'GPA') THEN
C        ISADJ=3
C      ELSE IF(CARLIR .EQ. 'GA') THEN
C        ISADJ=4
      ELSE
        GO TO 2000
      ENDIF
      GO TO 1000
 2000 CONTINUE
      IF(ISDIR .GT. 0) THEN
        IRSDIR(ISDIR)=-1
      ENDIF
      CARLST=CARLIR
      RETURN
      END
