*DECK FLUQFX
      SUBROUTINE FLUQFX(IPMACR,IPRINT,NGROUP,NBMIX ,NREGIO,NUNKNO,
     >                  MATCOD,KEYFLX,CFIXSR,SUNKNO,XSA   )
C
C---------------------------  FLUQFX  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : FLUQFX
C       USE      : ADD FIXED SOURCES TO SUNKNO
C       MODIFIED : 94-06-23
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT:
C      IPMACR  : POINTER TO THE MACROLIB              I
C      IPRINT  : PRINT SELECTION FOR FLUX MODULES:    I
C                >= 100 PRINT FIXED SOURCES
C      NGROUP  : NUMBER OF GROUPS.                    I
C      NBMIX   : NUMBER OF MIXTURES.                  I
C      NREGIO  : NUMBER OF REGIONS.                   I
C      NUNKNO  : NUMBER OF UNKNOWN IN THE SYSTEM.     I
C      MATCOD  : MATERIAL CODE IN REGIONS.            I(NREGIO)
C      KEYFLX  : FLUX ELEMENTS IN UNKNOWN SYSTEM.     I(NREGIO)
C      CFIXSR  : NAME OF GENERALIZED ADJOINT SOURCE   C*12
C    OUTPUT
C      SUNKNO  : SOURCE FOR SYSTEM OF UNKNOWN.        R(NUNKNO,NGROUP)
C    SCRATCH STORAGE:
C      XSA     : ARBITRARY XS VECTOR                  R(0:NBMIX)
C                XSA(0) ALREADY INITIALIZED TO 0.0
C
C   3- INTERNAL PARAMETERS:
C      CGRPNM  : CHARACTER GROUP NAME                 C*12
C      IOUT  : OUTPUT UNIT                          P
C
C---------------------------   FLUQFX  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='FLUQFX')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPMACR,IPRINT,NGROUP,NBMIX,NREGIO,NUNKNO
      CHARACTER   CFIXSR*12
      INTEGER     MATCOD(NREGIO),KEYFLX(NREGIO)
      REAL        SUNKNO(NUNKNO,NGROUP),XSA(0:NBMIX)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CGRPNM*12
      INTEGER     IGR,IREG,IBM,ILCMLN,ILCMTY
C----
C  ADD FIXED SOURCES TO SUNKNO AT REGION LOCATION
C----
      DO 100 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
        CALL LCMLEN(IPMACR,CFIXSR,ILCMLN,ILCMTY)
        IF(ILCMLN .EQ. NBMIX) THEN
          CALL LCMGET(IPMACR,CFIXSR,XSA(1))
          DO 110 IREG=1,NREGIO
            IBM=MATCOD(IREG)
            SUNKNO(KEYFLX(IREG),IGR)=SUNKNO(KEYFLX(IREG),IGR)+XSA(IBM)
 110      CONTINUE
          IF(IPRINT .GE. 100) THEN
            WRITE(IOUT,6000) IGR
            WRITE(IOUT,6001)
     >        (IREG,XSA(MATCOD(IREG)),IREG=1,NREGIO)
          ENDIF
        ELSE
          CALL XABORT(NAMSBR//
     >    ': FIXED SOURCE '//CFIXSR//' NOT FOUND')
        ENDIF
        CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 100  CONTINUE
      RETURN
C----
C FORMATS
C----
 6000 FORMAT(1X,' REGIONAL FIXED SOURCES IN GROUP = ',I5)
 6001 FORMAT(1P,5(3X,I5,2X,E15.7))
      END
