*DECK GEO
      SUBROUTINE GEO(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C-----------------------------------------------------------------------
C
C GEOMETRY DEFINITION MODULE FOR DRAGON-2.
C
C INPUT/OUTPUT PARAMETERS:
C  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
C  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
C  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
C           =4 SEQUENTIAL ASCII FILE.
C  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
C           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
C           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
C  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
C           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
C           KENTRY(NENTRY)
C
C LINKED LISTS / XSM FILES:
C  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_GEOM).
C  HENTRY(2) : READ-ONLY OPTIONAL TYPE(L_GEOM).
C
C-------------------------------------- AUTHOR: A. HEBERT ; 22/09/94 ---
      IMPLICIT NONE
C----
C  SUBROUTINE PARAMETERS
C----
      INTEGER      IOUT
      PARAMETER   (IOUT=6)
      INTEGER      NENTRY
      CHARACTER    HENTRY(NENTRY)*12
      INTEGER      IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
C----
C  LOCAL VARIABLES
C----
      INTEGER      KCHAR(3),ITYPE,IPGEOM,IMPX,IPGEO2,I1,MAXMIX
      CHARACTER    TEXT12*12,TEXT13*12
C
C PARAMETER VALIDATION.
C
      IF(NENTRY.LT.1) CALL XABORT
     > ('GEO: AT LEAST ONE DATA STRUCTURE REQUIRED')
      IF(IENTRY(1).NE.1.AND.IENTRY(1).NE.2) CALL XABORT
     >  ('GEO: FIRST DATA STRUCTURE NOT A LINKED LIST OR XSM FILE')
      IF(JENTRY(1).NE.0.AND.JENTRY(1).NE.1) CALL XABORT
     >  ('GEO: FIRST DATA STRUCTURE NOT IN CREATE OR MODIFY MODE')
      ITYPE=JENTRY(1)
      IPGEOM=KENTRY(1)
*
      IMPX=1
      IF((ITYPE.EQ.0).AND.(NENTRY.GT.1)) THEN
*----
*  CREATE A NEW GEOMETRY BASED ON AN EXISTING ONE.
*----
        IF(IENTRY(2).NE.1.AND.IENTRY(2).NE.2) CALL XABORT
     >  ('GEO: SECOND DATA STRUCTURE NOT A LINKED LIST OR XSM FILE')
        IF(JENTRY(2).NE.2) CALL XABORT
     >  ('GEO: SECOND DATA STRUCTURE NOT IN READ-ONLY MODE')
         IPGEO2=KENTRY(2)
         CALL LCMGET(IPGEO2,'SIGNATURE',KCHAR)
         WRITE(TEXT12,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(TEXT12.NE.'L_GEOM') THEN
            TEXT13=HENTRY(2)
            CALL XABORT('GEO: SIGNATURE OF '//TEXT13//' IS '//TEXT12//
     1      '. L_GEOM EXPECTED(1).')
         ENDIF
         CALL LCMEQU(IPGEO2,IPGEOM)
      ELSE IF(ITYPE.EQ.1) THEN
*        MODIFY AN EXISTING GEOMETRY USING THE SAME NAME.
         CALL LCMGET(IPGEOM,'SIGNATURE',KCHAR)
         WRITE(TEXT12,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(TEXT12.NE.'L_GEOM') THEN
            TEXT13=HENTRY(1)
            CALL XABORT('GEO: SIGNATURE OF '//TEXT13//' IS '//TEXT12//
     1      '. L_GEOM EXPECTED(2).')
         ENDIF
      ENDIF
*
      TEXT12='/'
      CALL GEOIN1 (TEXT12,IPGEOM,1,IMPX,MAXMIX)
      RETURN
      END
