*DECK MRG
      SUBROUTINE MRG(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C
C-----------------------------------------------------------------------
C
C MERGE EXCELL GEOMETRY.
C
C INPUT/OUTPUT PARAMETERS:
C  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
C  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
C  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
C           =4 SEQUENTIAL ASCII FILE.
C  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
C           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
C           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
C  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
C           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
C           KENTRY(NENTRY)
C
C LINKED LIST / XSM FILE:
C  HENTRY(1) : CREATION MODE LINKED LIST TYPE(L_TRACK)
C  HENTRY(2) : CREATION MODE SEQUENTIAL BINARY TRACKING FILE.
C  HENTRY(3) : READ-ONLY LINKED LIST TYPE(L_TRACK)
C  HENTRY(4) : READ-ONLY SEQUENTIAL BINARY TRACKING FILE.
C
C------------------------------------- AUTHOR: G. MARLEAU ; 97/11/06 ---
C
      IMPLICIT         NONE
      INTEGER          IOUT,NSTATE,NTC,NALB
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NSTATE=20,NTC=18,NALB=6,
     >                 NAMSBR='MRG   ')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER          NENTRY,IENTRY(NENTRY),JENTRY(NENTRY),
     >                 KENTRY(NENTRY)
      CHARACTER        HENTRY(NENTRY)*12
C----
C  MEMORY ALLOCATION VARIABLES
C----
      INTEGER          IBASE(1)
      REAL             RBASE
      COMMON           RBASE(1)
      EQUIVALENCE     (RBASE(1),IBASE(1))
      INTEGER          NEXMEH,NEXIND,NEXICO,NEXMXD,NEXMND,
     >                 NEXRMH,NEXISR,NEXIFV,NEXIFA,NEXIPL,
     >                 NEXICL,NEXXRT,NEXXRI,NEXNRI,NEXRDR,
     >                 NEXNDR,NEXRRO,NEXNRO,NEXRAN,NEXMAN,
     >                 NEXKYN,IKEYN ,NEXKEY,NEXVOL,NEXMAT,
     >                 IVOLN ,IMATN ,IKEYO ,IVOLO ,IMATO ,
     >                 IDEN  ,IANG  ,IALB  ,ICODE ,IPATH ,
     >                 INRSEG,IMIXN ,IMERGE,MATRTO,MATRTN
C----
C  LOCAL VARIABLES
C----
      INTEGER          ISTATE(NSTATE),IPARAM(NSTATE),KCHAR(NTC),
     >                 IPTRKN,IFTRKN,IPTRKO,IFTRKO,NREGO,NUNO,NUNN,
     >                 NSURO,NCOMNT,NBTRK,NSCRP(8),IUPD(4),
     >                 NSOUTO,NVOUTO,NSOUTN,NVOUTN,ILCMLN,ILCMTY,
     >                 NDIM,ITROP,ITC,NALBG,MXSEG,NANGL,
     >                 NETNXX,NETNXS,NETNBA,NETNSX,NETNMH,NETCLA,
     >                 NETND2,NETND1,NETNRT,NUNKNO,NUNKNN,NETSUR,
     >                 NETMSR,NETCLT,NETNUN,NETNDI,NETMXR,
     >                 IPRINT,MAXMN,NETVOL
      CHARACTER        HSIGN*12,CTRK*4,COMENT*80
      REAL             ALBEDO(NALB),ALBEDN(NALB),EXTKOP(3),COTNET
*
* PARAMETER VALIDATION.
      IF(NENTRY .LT. 4) CALL XABORT(NAMSBR//
     >  ': AT LEAST FOUR DATA STRUCTURES REQUIRED')
      IPTRKN=KENTRY(1)
      IFTRKN=KENTRY(2)
      IPTRKO=KENTRY(3)
      IFTRKO=KENTRY(4)
      IF(IENTRY(1) .NE. 1) CALL XABORT(NAMSBR//
     >  ': FIRST DATA STRUCTURE NOT A LINKED LIST')
      IF(JENTRY(1) .NE. 0) CALL XABORT(NAMSBR//
     >  ': FIRST DATA STRUCTURE NOT IN CREATE MODE')
      IF(IENTRY(2) .NE. 3) CALL XABORT(NAMSBR//
     >  ': SECOND DATA STRUCTURE NOT SEQUENTIAL BINARY FILE')
      IF(JENTRY(2) .NE. 0) CALL XABORT(NAMSBR//
     >  ': SECOND DATA STRUCTURE NOT IN CREATE MODE')
      IF(IENTRY(3) .NE. 1) CALL XABORT(NAMSBR//
     >  ': THIRD DATA STRUCTURE NOT A LINKED LIST')
      IF(JENTRY(3) .NE. 2) CALL XABORT(NAMSBR//
     >  ': THIRD DATA STRUCTURE NOT IN READ-ONLY MODE')
      IF(IENTRY(4) .NE. 3) CALL XABORT(NAMSBR//
     >  ': SECOND DATA STRUCTURE NOT SEQUENTIAL BINARY FILE')
      IF(JENTRY(4) .NE. 2) CALL XABORT(NAMSBR//
     >  ': SECOND DATA STRUCTURE NOT IN CREATE MODE')
      CALL LCMGET(IPTRKO,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
      IF(HSIGN .NE. 'L_TRACK') CALL XABORT(NAMSBR//
     >  ': SIGNATURE OF '//HENTRY(3)//' IS '//HSIGN//
     >  '. L_TRACK EXPECTED.')
      CALL LCMPUT(IPTRKN,'SIGNATURE',3,3,KCHAR)
      CALL LCMGET(IPTRKO,'TRACK-TYPE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
      IF(HSIGN .NE. 'EXCELL') CALL XABORT(NAMSBR//
     >  ': ILLEGAL TRACKING FORMAT')
      CALL LCMPUT(IPTRKN,'TRACK-TYPE',3,3,KCHAR)
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPTRKO,'STATE-VECTOR',ISTATE)
      NREGO=ISTATE(1)
      NUNO=ISTATE(2)
      NSURO=ISTATE(5)
      ITROP=ISTATE(7)
      READ (IFTRKO) CTRK,NCOMNT,NBTRK
      WRITE(IFTRKN) CTRK,NCOMNT,NBTRK
      DO 100 ITC= 1, NCOMNT
        READ (IFTRKO) COMENT
        WRITE(IFTRKN) COMENT
 100  CONTINUE
      READ (IFTRKO) (NSCRP(ITC),ITC=1,8)
      IF(NSCRP(3) .NE. NREGO) CALL XABORT(NAMSBR//
     >  ': NUMBER OF REGION INCOMPATIBLE')
      IF(NSCRP(4) .NE. NSURO) CALL XABORT(NAMSBR//
     >  ': NUMBER OF SURFACES INCOMPATIBLE')
      NDIM  =NSCRP(1)
      NVOUTO=NSCRP(3)
      NSOUTO=NSCRP(4)
      NALBG= NSCRP(5)
      NANGL= NSCRP(7)
      MXSEG= NSCRP(8)
C----
C  REAG MERGE INFORMATION
C----
      CALL SETARA(IBASE,NSOUTO+NVOUTO+1,IMERGE)
      CALL SETARA(IBASE,NVOUTO,IMIXN)
      CALL MRGGET(IPRINT,NSOUTO,NVOUTO,NSOUTN,NVOUTN,
     >            IUPD,IBASE(IMERGE),IBASE(IMIXN),ALBEDO)
      NSCRP(3)=NVOUTN
      NSCRP(4)=NSOUTN
      NUNN=NUNO+NVOUTN-NVOUTO
C----
C  MERGE IPTRKO INFORMATION TO IPTRKN
C----
      CALL SETARA(IBASE,NVOUTO,IMATO)
      CALL SETARA(RBASE,NVOUTO,IVOLO)
      CALL SETARA(IBASE,NREGO,IKEYO)
      CALL SETARA(IBASE,NVOUTN,IMATN)
      CALL SETARA(RBASE,NVOUTN,IVOLN)
      CALL SETARA(IBASE,NREGO,IKEYN)
      CALL SETARA(IBASE,NSOUTO,MATRTO)
      CALL SETARA(IBASE,NSOUTO,MATRTN)
      CALL LCMLEN(IPTRKO,'TITLE       ',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. 0) THEN
        READ(CTRK,'(A4)') ITC
        CALL XDISET(KCHAR,NTC,ITC)
      ELSE
        CALL LCMGET(IPTRKO,'TITLE       ',KCHAR)
      ENDIF
      CALL LCMGET(IPTRKO,'EXCELTRACKOP',EXTKOP)
      CALL LCMGET(IPTRKO,'ALBEDO      ',ALBEDO)
      CALL LCMGET(IPTRKO,'MATCOD      ',IBASE(IMATO))
      CALL LCMGET(IPTRKO,'VOLUME      ',RBASE(IVOLO))
      CALL LCMGET(IPTRKO,'KEYFLX      ',IBASE(IKEYO))
      CALL LCMLEN(IPTRKO,'BC-REFL+TRAN',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. NSOUTO) THEN
        CALL LCMGET(IPTRKO,'BC-REFL+TRAN',IBASE(MATRTO))
      ELSE
        DO 110 ITC=0,NSOUTO-1
          IBASE(MATRTO+ITC)=ITC+1
 110    CONTINUE
      ENDIF
C----
C  READ SPECIFIC EXCELL GEOMETRY OPTIONS
C----
      CALL LCMSIX(IPTRKO,'EXCELL      ',1)
      CALL LCMSIX(IPTRKN,'EXCELL      ',1)
      CALL XDISET(IPARAM,NSTATE,0)
      CALL LCMGET(IPTRKO,'STATE-VECTOR',IPARAM)
      NETSUR=IPARAM(2)
      NETVOL=IPARAM(3)
      NETNUN=IPARAM(6)
      CALL SETARA(IBASE,NETNUN,NEXKEY)
      CALL SETARA(RBASE,NETNUN,NEXVOL)
      CALL SETARA(IBASE,NETNUN,NEXMAT)
      CALL LCMGET(IPTRKO,'MATALB      ',IBASE(NEXMAT))
      CALL LCMGET(IPTRKO,'VOLSUR      ',RBASE(NEXVOL))
      CALL LCMGET(IPTRKO,'KEYMRG      ',IBASE(NEXKEY))
      IF(ITROP .EQ. 1) THEN
       NETCLT=IPARAM(4)
       NETMXR=IPARAM(5)
C----
C  READ OLD CARTESIAN INFORMATION
C----
        CALL SETARA(IBASE,NETCLT,NEXMND)
        CALL SETARA(IBASE,NETCLT,NEXMXD)
        CALL SETARA(IBASE,NETCLT,NEXICO)
        CALL SETARA(IBASE,4*NETNUN,NEXIND)
        CALL SETARA(RBASE,NETMXR,NEXMEH)
        CALL LCMGET(IPTRKO,'MINDIM      ',IBASE(NEXMND))
        CALL LCMGET(IPTRKO,'MAXDIM      ',IBASE(NEXMXD))
        CALL LCMGET(IPTRKO,'ICORD       ',IBASE(NEXICO))
        CALL LCMGET(IPTRKO,'INDEX       ',IBASE(NEXIND))
        CALL LCMGET(IPTRKO,'REMESH      ',RBASE(NEXMEH))
C----
C  SAVE NEW CARTESIAN INFORMATION EXCEPT KEYMRG
C----
        CALL LCMPUT(IPTRKN,'MINDIM      ',NETCLT,1,IBASE(NEXMND))
        CALL LCMPUT(IPTRKN,'MAXDIM      ',NETCLT,1,IBASE(NEXMXD))
        CALL LCMPUT(IPTRKN,'ICORD       ',NETCLT,1,IBASE(NEXICO))
        CALL LCMPUT(IPTRKN,'INDEX       ',4*NETNUN,1,IBASE(NEXIND))
        CALL LCMPUT(IPTRKN,'REMESH      ',NETMXR,2,RBASE(NEXMEH))
        CALL RLSARA(RBASE(NEXMEH))
        CALL RLSARA(IBASE(NEXIND))
        CALL RLSARA(IBASE(NEXICO))
        CALL RLSARA(IBASE(NEXMXD))
        CALL RLSARA(IBASE(NEXMND))
      ELSE IF(ITROP .EQ. 2) THEN
C----
C  READ OLD HEXAGONAL INFORMATION
C----
        NETNDI=IPARAM(1)
        NETCLA=IPARAM(4)
        NETNMH=IPARAM(5)
        NETND1=IPARAM(10)
        NETND2=IPARAM(11)
        NETNXS=IPARAM(12)
        NETNXX=IPARAM(13)
        CALL SETARA(IBASE,NETND1,NEXICL)
        CALL SETARA(IBASE,NETND2,NEXIPL)
        CALL SETARA(IBASE,NETNXX,NEXIFA)
        CALL SETARA(IBASE,NETCLA,NEXIFV)
        CALL SETARA(IBASE,NETNXS,NEXISR)
        CALL SETARA(RBASE,NETNMH,NEXRMH)
        CALL LCMGET(IPTRKO,'ICEL        ',IBASE(NEXICL))
        CALL LCMGET(IPTRKO,'IPLAN       ',IBASE(NEXIPL))
        IF(NETNDI .EQ. 3)
     >  CALL LCMGET(IPTRKO,'IFACB       ',IBASE(NEXIFA))
        CALL LCMGET(IPTRKO,'IFVV        ',IBASE(NEXIFV))
        CALL LCMGET(IPTRKO,'ISURB       ',IBASE(NEXISR))
        CALL LCMGET(IPTRKO,'REMESH      ',RBASE(NEXRMH))
C----
C  SAVE NEW HEXAGONAL INFORMATION EXCEPT KEYMRG
C----
        CALL LCMPUT(IPTRKN,'ICEL        ',NETND1,1,IBASE(NEXICL))
        CALL LCMPUT(IPTRKN,'IPLAN       ',NETND2,1,IBASE(NEXIPL))
        IF(NETNDI .EQ. 3)
     >  CALL LCMPUT(IPTRKN,'IFACB       ',NETNXX,1,IBASE(NEXIFA))
        CALL LCMPUT(IPTRKN,'IFVV        ',NETCLA,1,IBASE(NEXIFV))
        CALL LCMPUT(IPTRKN,'ISURB       ',NETNXS,1,IBASE(NEXISR))
        CALL LCMPUT(IPTRKN,'REMESH      ',NETNMH,2,RBASE(NEXRMH))
        CALL RLSARA(RBASE(NEXRMH))
        CALL RLSARA(IBASE(NEXISR))
        CALL RLSARA(IBASE(NEXIFV))
        CALL RLSARA(IBASE(NEXIFA))
        CALL RLSARA(IBASE(NEXIPL))
        CALL RLSARA(IBASE(NEXICL))
      ELSE IF(ITROP .EQ. 3) THEN
C----
C  READ OLD CLUSTER INFORMATION
C----
        NETNSX=IPARAM(4)
        NETNBA=IPARAM(5)
        NETNRT=IPARAM(7)
        NETMSR=IPARAM(8)
        CALL SETARA(RBASE,NETNBA       ,NEXRAN)
        CALL SETARA(IBASE,3*NETNRT     ,NEXNRO)
        CALL SETARA(RBASE,2*NETNRT     ,NEXRRO)
        CALL SETARA(IBASE,NETNRT       ,NEXNDR)
        CALL SETARA(RBASE,NETMSR*NETNRT,NEXRDR)
        CALL SETARA(IBASE,2*NETNBA     ,NEXNRI)
        CALL SETARA(IBASE,NETNBA*NETNRT,NEXXRI)
        CALL SETARA(IBASE,NETNRT       ,NEXXRT)
        CALL LCMGET(IPTRKO,'RAN         ',RBASE(NEXRAN))
        IF(NETNSX .EQ. 4)
     >  CALL LCMGET(IPTRKO,'COTE        ',COTNET       )
        CALL LCMGET(IPTRKO,'NRODS       ',IBASE(NEXNRO))
        CALL LCMGET(IPTRKO,'RODS        ',RBASE(NEXRRO))
        CALL LCMGET(IPTRKO,'NRODR       ',IBASE(NEXNDR))
        CALL LCMGET(IPTRKO,'RODR        ',RBASE(NEXRDR))
        CALL LCMGET(IPTRKO,'NRINFO      ',IBASE(NEXNRI))
        CALL LCMGET(IPTRKO,'NXRI        ',IBASE(NEXXRI))
        CALL LCMGET(IPTRKO,'NXRS        ',IBASE(NEXXRT))
C----
C  SAVE NEW CLUSTER INFORMATION EXCEPT KEYMRG
C----
        CALL LCMPUT(IPTRKN,'RAN         ',NETNBA       ,2,RBASE(NEXRAN))
        IF(NETNSX .EQ. 4)
     >  CALL LCMPUT(IPTRKN,'COTE        ',1            ,2,COTNET       )
        CALL LCMPUT(IPTRKN,'NRODS       ',3*NETNRT     ,1,IBASE(NEXNRO))
        CALL LCMPUT(IPTRKN,'RODS        ',2*NETNRT     ,2,RBASE(NEXRRO))
        CALL LCMPUT(IPTRKN,'NRODR       ',NETNRT       ,1,IBASE(NEXNDR))
        CALL LCMPUT(IPTRKN,'RODR        ',NETMSR*NETNRT,2,RBASE(NEXRDR))
        CALL LCMPUT(IPTRKN,'NRINFO      ',2*NETNBA     ,1,IBASE(NEXNRI))
        CALL LCMPUT(IPTRKN,'NXRI        ',NETNRT*NETNBA,1,IBASE(NEXXRI))
        CALL LCMPUT(IPTRKN,'NXRS        ',NETNRT       ,1,IBASE(NEXXRT))
        CALL RLSARA(IBASE(NEXXRT))
        CALL RLSARA(IBASE(NEXXRI))
        CALL RLSARA(IBASE(NEXNRI))
        CALL RLSARA(RBASE(NEXRDR))
        CALL RLSARA(IBASE(NEXNDR))
        CALL RLSARA(RBASE(NEXRRO))
        CALL RLSARA(IBASE(NEXNRO))
        CALL RLSARA(RBASE(NEXRAN))
      ELSE
         CALL XABORT(NAMSBR//
     >  ': INVALID EXCELL TRACKING OPTION')
      ENDIF
      CALL LCMSIX(IPTRKO,'EXCELL      ',2)
      CALL SETARA(IBASE,NETNUN,NEXKYN)
      CALL SETARA(IBASE,NETNUN,NEXMAN)
      CALL MRGVOL(IUPD  ,NSOUTO,NVOUTO,NSOUTN,NVOUTN,NREGO ,
     >            IBASE(IMERGE),IBASE(IMIXN) ,IBASE(IMATO) ,
     >            RBASE(IVOLO) ,IBASE(IMATN) ,RBASE(IVOLN) ,
     >            IBASE(IKEYN) ,IBASE(MATRTO),IBASE(MATRTN),
     >            MAXMN ,NETVOL,NETSUR,
     >            IBASE(NEXKEY),IBASE(NEXMAT),IBASE(NEXKYN),
     >            IBASE(NEXMAN))
C----
C  SAVE KEYMRG, MATALB AND VOLSUR AND IPARAM
C----
      CALL LCMPUT(IPTRKN,'MATALB      ',NETNUN,1,IBASE(NEXMAN))
      CALL LCMPUT(IPTRKN,'VOLSUR      ',NETNUN,2,RBASE(NEXVOL))
      CALL LCMPUT(IPTRKN,'KEYMRG      ',NETNUN,1,IBASE(NEXKYN))
      CALL LCMPUT(IPTRKN,'STATE-VECTOR',NSTATE,1,IPARAM)
      CALL LCMSIX(IPTRKN,'EXCELL      ',2)
      CALL RLSARA(IBASE(NEXMAN))
      CALL RLSARA(IBASE(NEXKYN))
      CALL RLSARA(IBASE(NEXMAT))
      CALL RLSARA(RBASE(NEXVOL))
      CALL RLSARA(IBASE(NEXKEY))
      ISTATE(1)=NVOUTN
      ISTATE(2)=NUNN
      ISTATE(4)=MAXMN
      ISTATE(5)=NSOUTN
      CALL LCMPUT(IPTRKN,'STATE-VECTOR',NSTATE,1,ISTATE)
      CALL LCMPUT(IPTRKN,'TITLE       ',NTC,3,KCHAR)
      CALL LCMPUT(IPTRKN,'EXCELTRACKOP',3,2,EXTKOP)
      IF(IPRINT .GE. 1) THEN
        WRITE(IOUT,6000) IPRINT,10,(ISTATE(ITC),ITC=1,10)
        WRITE(IOUT,6001)(EXTKOP(ITC),ITC=1,3)
      ENDIF
      IF(IUPD(4). GT. 0 ) THEN
        CALL LCMPUT(IPTRKN,'ALBEDO      ',NALB,2,ALBEDN)
      ELSE
        CALL LCMPUT(IPTRKN,'ALBEDO      ',NALB,2,ALBEDO)
      ENDIF
      CALL LCMPUT(IPTRKN,'MATCOD      ',NVOUTN,1,IBASE(IMATN))
      CALL LCMPUT(IPTRKN,'VOLUME      ',NVOUTN,2,RBASE(IVOLN))
      IF(IUPD(1) .GT. 0 ) THEN
        CALL LCMPUT(IPTRKN,'KEYFLX      ',NVOUTN,1,IBASE(IKEYN))
      ELSE
        CALL LCMPUT(IPTRKN,'KEYFLX      ',NREGO,1,IBASE(IKEYO))
      ENDIF
      CALL LCMPUT(IPTRKN,'BC-REFL+TRAN',NSOUTN,1,IBASE(MATRTN))
      CALL RLSARA(IBASE(MATRTN))
      CALL RLSARA(IBASE(MATRTO))
      CALL RLSARA(IBASE(IKEYN))
      CALL RLSARA(RBASE(IVOLN))
      CALL RLSARA(IBASE(IMATN))
      CALL RLSARA(IBASE(IKEYO))
      CALL RLSARA(RBASE(IVOLO))
      CALL RLSARA(IBASE(IMATO))
C----
C  MERGE IFTRKO INFORMATION TO IFTRKN
C----
      WRITE(IFTRKN) (NSCRP(ITC),ITC=1,8)
      CALL SETARA(IBASE,NSOUTO+NVOUTO+1,IMATO)
      CALL SETARA(RBASE,NSOUTO+NVOUTO+1,IVOLO)
      CALL SETARA(IBASE,NSOUTN+NVOUTN+1,IMATN)
      CALL SETARA(RBASE,NSOUTN+NVOUTN+1,IVOLN)
      NUNKNO=NSOUTO+NVOUTO
      READ (IFTRKO) (RBASE(IVOLO+ITC),ITC=0,NUNKNO)
      READ (IFTRKO) (IBASE(IMATO+ITC),ITC=0,NUNKNO)
      CALL MRGVST(IPRINT,IUPD,NSOUTO,NVOUTO,NSOUTN,NVOUTN,
     >            IBASE(IMERGE),IBASE(IMIXN),IBASE(IMATO),
     >            RBASE(IVOLO),IBASE(IMATN),RBASE(IVOLN))
      NUNKNN=NSOUTN+NVOUTN
      WRITE(IFTRKN) (RBASE(IVOLN+ITC),ITC=0,NUNKNN)
      WRITE(IFTRKN) (IBASE(IMATN+ITC),ITC=0,NUNKNN)
      CALL RLSARA(RBASE(IVOLN))
      CALL RLSARA(IBASE(IMATN))
      CALL RLSARA(RBASE(IVOLO))
      CALL RLSARA(IBASE(IMATO))
      CALL SETARA(IBASE,NALBG,ICODE)
      CALL SETARA(RBASE,NALBG,IALB)
      CALL SETARA(RBASE,NDIM*NANGL,IANG)
      CALL SETARA(RBASE,NANGL,IDEN)
      READ (IFTRKO) (IBASE(ICODE+ITC),ITC=0,NALBG-1)
      READ (IFTRKO) (RBASE(IALB+ITC),ITC=0,NALBG-1)
      READ (IFTRKO) (RBASE(IANG+ITC),ITC=0,NDIM*NANGL-1)
      READ (IFTRKO) (RBASE(IDEN+ITC),ITC=0,NANGL-1)
      WRITE(IFTRKN) (IBASE(ICODE+ITC),ITC=0,NALBG-1)
      IF(IUPD(4). GT. 0 ) THEN
        WRITE(IFTRKN) (ALBEDN(ITC),ITC=1,NALBG)
      ELSE
        WRITE(IFTRKN) (RBASE(IALB+ITC),ITC=0,NALBG-1)
      ENDIF
      WRITE(IFTRKN) (RBASE(IANG+ITC),ITC=0,NDIM*NANGL-1)
      WRITE(IFTRKN) (RBASE(IDEN+ITC),ITC=0,NANGL-1)
      CALL RLSARA(RBASE(IDEN))
      CALL RLSARA(RBASE(IANG))
      CALL RLSARA(RBASE(IALB))
      CALL RLSARA(IBASE(ICODE))
C----
C  TRACKING LINE
C----
      CALL SETARA(IBASE,MXSEG,INRSEG)
      CALL SETARA(RBASE,MXSEG,IPATH)
      CALL MRGLIN(IPRINT,IFTRKO,NSOUTO,NVOUTO,IFTRKN,
     >            IBASE(IMERGE),MXSEG,IBASE(INRSEG),RBASE(IPATH))
      CALL RLSARA(RBASE(IPATH))
      CALL RLSARA(IBASE(INRSEG))
      CALL RLSARA(IBASE(IMIXN))
      CALL RLSARA(IBASE(IMERGE))
      RETURN
C----
C  FORMATS
C----
 6000 FORMAT(' MRG PRINT LEVEL =',I8/
     > ' TRACK STATE-VECTOR  (',I2,') ELEMENTS'/
     > ' -----------------'/
     > ' NREG   =',I8,' (NUMBER OF REGIONS)'/
     > ' NUNKNO =',I8,' (NUMBER OF UNKNOWNS IN SYSTEM)'/
     > ' ILEAK  =',I8,' (LEAKAGE FLAG)'/
     > ' MAXMIX =',I8,' (NUMBER OF MIXTURES)'/
     > ' NSOUT  =',I8,' (NUMBER OF OUTER SURFACES)'/
     > ' NANIS  =',I8,' (FLUX ANISOTROPY ORDER)'/
     > ' NORE   =',I8,' (TRACK NORMALIZATION OPTION)'/
     > ' KSEPC  =',I8,' (FLAG FOR SPECULAR TRACKING)'/
     > ' NANGL  =',I8,' (NUMBER OF TRACKING ANGLES)'/
     > ' ISYMM  =',I8,' (TRACKING SYMMETRY FACTOR)'/
     > ' -----------------'/ )
 6001 FORMAT(
     > ' EXCELL TRACK OPTIONS '/
     > ' CUTOFX =',F20.8,' (CUTOFF FOR TRACK LENGTH)'/
     > ' DENS   =',F20.8,' (TRACK DENSITY)'/
     > ' PCORN  =',F20.8,' (CORNER DUPLICATION DISTANCE)'/
     > ' -----------------'/ )
      END
