*DECK PERPER
      SUBROUTINE PERPER(IPFLUR,IPFLUP,IPEDIT,NBMIX ,NGROUP,MXNL  ,
     >                  NIFISS,MAXFIS,NUNKNO,NREGIO,LOLXSP,KEFFP ,
     >                  NMERGE,IXSFL ,MNIFIS,NAME  ,NGCOND,NTAUXT,
     >                  NEDMAC,EIGENK,NAMSAV,INDICE,LCOR  ,
     >                  KEYFLX,MATCOD,VOLUME,
     >                  IMERGE,IGCOND,XSTOTP,
     >                  XSTRAP,XSFISP,XSFIXP,
     >                  XSSCAP,FUNKNO,FGAMMA,
     >                  DFINT ,DFRINT,RATECM,
     >                  SCATTD,NAMEAD,VARFLU,
     >                  VARCOR,XSABSP)
C
C---------------------------  PERPER ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : PEPER
C       USE      : COMPUTE PERTURBATIONS
C       AUTHOR   : T. COURAU (2000-08-01)
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPFLUR   : POINTER TO THE FLUX                I
C       IPFLUP   : POINTER TO THE PERTURBED FLUX    I
C       IPEDIT   : POINTER TO THE EDITION             I
C       NBMIX    : MAXIMUM NUMBER OF MIXTURES         I
C       NGROUP   : NUMBER OF ENERGY GROUPS            I
C       MXNL     : MAXIMUM LEGENDRE ORDER             I
C                  = 1 ISOTROPIC COLLISION
C                  = 2 LINEARLY ANISOTROPIC COLLISION
C       NIFISS   : NUMBER OF FISSILE ISOTOPES         I
C       MAXFIS   : MAX(1,NIFISS)                      I
C       NUNKNO   : NUMBER OF UNKNOWN FOR THE FLUX     I
C       NREGIO   : NUMBER OF REGIONS                  I
C       LOLXSP   : CHECK IF CROSS SECTION TYPE IS     L(NBXS)
C                  TO BE TREATED
C                1 TOTAL, 2 NUSIGF, 3 FIXE, 4 CHI, 5  SCAD
C                6 TRANC, 7 FIXA, 8 FIXG, 9 NFTOT, 10 EFISS
C       NMERGE   : NUMBER OF REGIONS MERGED           I
C       IXSFL    : FLAG FOR THE XS TO BE TREATED      I(NNAM+1)
C                1 TOTAL, 2 TRANC, 3 NUSIGF, 4 NFTOT,
C                5 CHI, 6  SCAD
C       MNIFIS   : MERGED NUMBER OF FISSILE ISOTOPES  I
C                  (SHOULD BE EQUAL TO 1)
C       NAME     : LIST OF STANDARD XS CONSIDERED     C(NNAM)*6
C       NGCOND   : NUMBER OF GROUPS CONDENSED         I
C       NTAUXT   : NUMBER OF  HOMOGENIZED XS EDITS    I
C       NEDMAC   : NUMBER OF ADITIONAL EDITION X-S    I
C       EIGENK   : EIGENVALUE FOR PROBLEM             R
C       NAMSAV   : NAME OF THE DIRECTORY WHERE THE
C                  INFORMATION IS STORED              C(12)
C       INDICE   : INDEX OF THE STANDARD XS           I(NNAM)
C       LCOR     : FLAG FOR THE HIGH ORDER FLUX       L
C                  COMPONENT
C       KEYFLX   : FLUX ELEMENTS IN UNKNOWN SYSTEM.   I(NREGIO)
C       MATCOD   : MATERIAL CODE IN REGIONS.          I(NREGIO)
C       VOLUME   : VOLUME OF REGIONS. DIMENSION       R(NREGIO)
C       XSTOT    : TOTAL CROSS SECTION OF MIXTURE     R(NBMIX,NGROUP)
C       XSABS    : ABS CROSS SECTION OF MIXTURE       R(NBMIX,NGROUP)
C       XSTRA    : TRANSPORT CORRECTION XS OF MIXTURE R(NBMIX,NGROUP)
C       XSFIS    : FISSION CROSS SECTION OF MIXTURE   R(NBMIX,
C                                                     MAXFIS,NGROUP,3)
C       XSFIX    : FIXE SOURCES                       R(NBMIX,
C                                                       NGROUP,3)
C       XSSCA    : SCATT X-SECTION OF MIXTURE/GROUP   R(NBMIX,MXNL,
C                                                      NGROUP,NGROUP)
C       VARFLU   : STORE VECTOR TO BE MULTILIED       R(NREGIO,NGROUP)
C                  BY GENERALIZED PSEUDO ADJOINT FLUXES
C       VARCOR   : STORE VECTOR TO BE MULTILIED       R(NREGIO,NGROUP)
C                  BY GENERALIZED ADJOINT FLUXES
C                  (HIGH ORDER COMPONENT)
C
C---------------------------   PERPER  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN,NBXS,NNAM
      CHARACTER   NAMSBR*6
      DOUBLE PRECISION PERSCA
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,NBXS=10,NNAM=6,
     >            NAMSBR='PERPER')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPFLUR,IPFLUP,IPEDIT,NBMIX,NGROUP,MXNL,NIFISS,MAXFIS,
     >            NUNKNO,NREGIO ,KEYFLX(NREGIO), MATCOD(NREGIO), NMERGE,
     >            NGCOND,IMERGE(NREGIO),IGCOND(NGCOND),IXSFL(NNAM+1),
     >            NEDMAC,NTAUXT,NAMEAD(2,NEDMAC)
      CHARACTER   NAME(NNAM)*6,HVECT(NEDMAC)*6,NAMSAV*12
      REAL        VOLUME(NREGIO) ,XSTOTP(NBMIX,NGROUP),
     >            XSTRAP(NBMIX,NGROUP),XSFISP(NBMIX,MAXFIS,NGROUP,3),
     >            XSFIXP(NBMIX,NGROUP,3),
     >            XSSCAP(NGROUP,NBMIX,MXNL,NGROUP),
     >            FUNKNO(NUNKNO,NGROUP),FGAMMA(NUNKNO,NGROUP),
     >            VARFLU(NREGIO,NGROUP),VARCOR(NREGIO,NGROUP),
     >            KEFFP,EIGENK
      REAL        XSABSP(NBMIX,NGROUP)
      LOGICAL     LOLXSP(NBXS),LCOR
      DOUBLE PRECISION DFINT(NMERGE,NGCOND), DFRINT(NMERGE,NGCOND),
     >               RATECM(0:NMERGE,NGCOND,NTAUXT),
     >               SCATTD(NMERGE,NGCOND,NGCOND,MXNL)
C----
C  MEMORY ALLOCATION
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     ISCATC,IIJJ,INJJ,IIPOS,IFACT
C----
C LOCAL PARAMETERS
C---
      INTEGER     IGR,JGR,IREG,IPFLUX,IGRC,JGRC,IMRG,INAM,IGRFIN,IGRDEB,
     >            JGRFIN,JGRDEB,IMIX,IL,ITRANC,MNIFIS,ID,
     >            IFISS,INDICE(NNAM)
      CHARACTER   NAMGPA*12,NAMREF*12
      DOUBLE PRECISION DDIREC,DINDIR
C---
C READ FLUX AND PERTURBED FLUX (IF IFLUP>0)
C--
      CALL XDDSET(DFRINT,NMERGE*NGCOND,0.0D0)
      IF (IPFLUP.GT.0) THEN
       IPFLUX=IPFLUP
       CALL XDRSET(FUNKNO,NGROUP*NUNKNO,0.0)
       CALL LCMSIX(IPFLUR,'FLUXDIRECT  ',ILCMUP)
       CALL FLUGFL(IPFLUR,NGROUP,NUNKNO,FUNKNO)
       CALL LCMSIX(IPFLUR,'FLUXDIRECT  ',ILCMDN)
       IGRFIN=0
       DO 10 IGRC=1,NGCOND
         IGRDEB=IGRFIN+1
         IGRFIN=IGCOND(IGRC)
         DO 20 IGR=IGRDEB,IGRFIN
           DO 30 IMRG=1,NMERGE
              DO 40 IREG=1,NREGIO
               IF(IMERGE(IREG).EQ.IMRG) THEN
                DFRINT(IMRG,IGRC)=DFRINT(IMRG,IGRC)+
     >            FUNKNO(KEYFLX(IREG),IGR)*VOLUME(IREG)
               ENDIF
 40           CONTINUE
 30        CONTINUE
 20      CONTINUE
 10    CONTINUE
      ELSE
       IPFLUX=IPFLUR
      ENDIF
      CALL XDRSET(FUNKNO,NGROUP*NUNKNO,0.0)
      CALL LCMSIX(IPFLUX,'FLUXDIRECT  ',ILCMUP)
      CALL FLUGFL(IPFLUX,NGROUP,NUNKNO,FUNKNO)
      CALL LCMSIX(IPFLUX,'FLUXDIRECT  ',ILCMDN)
C---
C INTEGRATED FLUX COMPUTATION
C---
      CALL XDDSET(DFINT,NMERGE*NGCOND,0.0D0)
      IGRFIN=0
      DO 100 IGRC=1,NGCOND
         IGRDEB=IGRFIN+1
         IGRFIN=IGCOND(IGRC)
         DO 200 IMRG=1,NMERGE
           DO 300 IGR=IGRDEB,IGRFIN
              DO 400 IREG=1,NREGIO
               IF(IMERGE(IREG).EQ.IMRG) THEN
                DFINT(IMRG,IGRC)=DFINT(IMRG,IGRC)+
     >            FUNKNO(KEYFLX(IREG),IGR)*VOLUME(IREG)
               ENDIF
 400          CONTINUE
 300       CONTINUE
         IF(IPFLUP.EQ.0)  DFRINT(IMRG,IGRC)=DFINT(IMRG,IGRC)
 200     CONTINUE
 100  CONTINUE
C---
C READ REFERENCE  HOMOGENIZED DATA WITH PERIXS
C---
      NAMREF='MACROREF    '
      CALL SETARA(RBASE,NMERGE*NGCOND,ISCATC)
      CALL SETARA(IBASE,NMERGE,IIJJ)
      CALL SETARA(IBASE,NMERGE,INJJ)
      CALL SETARA(IBASE,NMERGE,IIPOS)
      CALL SETARA(RBASE,NMERGE,IFACT)
      CALL PERIXS(IPEDIT,NAMREF,NGCOND,NMERGE,MXNL  ,ITRANC,
     >            MNIFIS,NEDMAC,NTAUXT,NNAM  ,NAMEAD,NAME  ,
     >            INDICE,IXSFL ,HVECT ,EIGENK,RATECM,SCATTD,
     >            RBASE(ISCATC) ,IBASE(IIJJ),IBASE(INJJ)  ,
     >            IBASE(IIPOS),RBASE(IFACT))
C---
C TREAT STANDARD XS
C---
      DO 500 INAM=1,NNAM
       IF (IXSFL(INAM).EQ.1) THEN
        IGRFIN=0
        DO 550 IGRC=1,NGCOND
         IGRDEB=IGRFIN+1
         IGRFIN=IGCOND(IGRC)
         DO 600 IMRG=1,NMERGE
          WRITE(NAMGPA,'(A6,2I2)') NAME(INAM),IGRC,IMRG
          DINDIR=PERSCA(
     >     IPFLUR,NAMGPA,NGROUP,NUNKNO,NREGIO,KEYFLX,FGAMMA,VARFLU)
          NAMGPA='A'//NAMGPA(2:12)
          IF (LCOR) DINDIR=DINDIR-PERSCA(
     >     IPFLUR,NAMGPA,NGROUP,NUNKNO,NREGIO,KEYFLX, FGAMMA,VARCOR)
          DDIREC=0.D0
          DO 700 IGR=IGRDEB,IGRFIN
            DO 800 IREG=1,NREGIO
              IMIX=MATCOD(IREG)
              IF(IMERGE(IREG).EQ.IMRG.AND.IMIX.GT.0) THEN
                IF(INAM.EQ.1.AND.LOLXSP(1))      THEN
                 DDIREC=DDIREC+XSTOTP(IMIX,IGR)*FUNKNO(KEYFLX(IREG),IGR)
     >                                         *VOLUME(IREG)
                ELSE IF(INAM.EQ.6)      THEN
                 DDIREC=DDIREC+XSABSP(IMIX,IGR)*FUNKNO(KEYFLX(IREG),IGR)
     >                                         *VOLUME(IREG)
                ELSE IF(INAM.EQ.2.AND.LOLXSP(6)) THEN
                 DDIREC=DDIREC+XSTRAP(IMIX,IGR)*FUNKNO(KEYFLX(IREG),IGR)
     >                                         *VOLUME(IREG)
                ELSEIF(INAM.EQ.3.AND.LOLXSP(2))  THEN
                 DO 810 IFISS=1,NIFISS
                  DDIREC=DDIREC+XSFISP(IMIX,IFISS,IGR,1)
     >                  *FUNKNO(KEYFLX(IREG),IGR)*VOLUME(IREG)
 810             CONTINUE
                ELSEIF(INAM.EQ.4.AND.LOLXSP(9))  THEN
                 DO 820 IFISS=1,NIFISS
                  DDIREC=DDIREC+XSFISP(IMIX,IFISS,IGR,2)
     >                  *FUNKNO(KEYFLX(IREG),IGR)*VOLUME(IREG)
 820             CONTINUE
                ENDIF
              ENDIF
 800        CONTINUE
 700      CONTINUE
          ID=INDICE(INAM)
          IF (INAM.EQ.1 .OR. INAM.EQ.2) THEN
C---
C TOTAL AND TRANC
C--
           RATECM(IMRG,IGRC,ID)=RATECM(IMRG,IGRC,ID)+(DDIREC
     >                     +DFRINT(IMRG,IGRC)*DINDIR)/DFINT(IMRG,IGRC)
           ELSE IF(INAM.EQ.3 .OR. INAM.EQ.4) THEN
C----
C NUSIGF AND NFTOT XS
C----
           RATECM(IMRG,IGRC,ID+1)=RATECM(IMRG,IGRC,ID+1)+(DDIREC
     >                     +DFRINT(IMRG,IGRC)*DINDIR)/DFINT(IMRG,IGRC)
          ELSE IF(INAM.EQ.6) THEN
C---
C ABS
C--
           RATECM(IMRG,IGRC,ID)=RATECM(IMRG,IGRC,ID)+(DDIREC
     >                     +DFRINT(IMRG,IGRC)*DINDIR)/DFINT(IMRG,IGRC)
C           RATECM(IMRG,IGRC,ID)=RATECM(IMRG,IGRC,ID)+(DDIREC
C     >                                              )/DFINT(IMRG,IGRC)
           ENDIF
 600     CONTINUE
 550    CONTINUE
       ENDIF
 500  CONTINUE
C---
C SCATTERING XS COMPUTATION LOOP
C---
c$$$       DO 900 IL=1,NL
        IF(IXSFL(NNAM+1).EQ.1) THEN
          IL=1
          IGRFIN=0
          DO 910 IGRC=1,NGCOND
            IGRDEB=IGRFIN+1
            IGRFIN=IGCOND(IGRC)
            DO 920 JGRC=1,NGCOND
              DO 930 IMRG=1,NMERGE
                DDIREC=0.D0
                WRITE(NAMGPA,'(A4,4I2)')'SCAD',IL-1,JGRC,IGRC,IMRG
C---
C READ GA SOURCE ASSOCIATED WITH SCAT(JGRC<-IGRC)
C---
               DINDIR=PERSCA(IPFLUR,NAMGPA,NGROUP,NUNKNO,NREGIO,KEYFLX,
     >                                                   FGAMMA,VARFLU)
               NAMGPA='A'//NAMGPA(2:12)
               IF(LCOR) DINDIR=DINDIR-PERSCA(IPFLUR,
     >            NAMGPA,NGROUP,NUNKNO,NREGIO,KEYFLX, FGAMMA,VARCOR)
                DO 940 IGR=IGRDEB,IGRFIN
                  IF (JGRC.EQ.1) THEN
                    JGRDEB=1
                  ELSE
                    JGRDEB=IGCOND(JGRC-1)+1
                  ENDIF
                  JGRFIN=IGCOND(JGRC)
                  DO 950 JGR=JGRDEB,JGRFIN
                    DO 960 IREG=1,NREGIO
                      IMIX=MATCOD(IREG)
                      IF(IMERGE(IREG).EQ.IMRG.AND.IMIX.GT.0) THEN
C---
C TREAT SCAT(IGR ->JGR )
C XSSCAP IS TRANSPOSED
C--
                       DDIREC=DDIREC+XSSCAP(IGR,IMIX,IL,JGR)
     >                       *FUNKNO(KEYFLX(IREG),IGR)*VOLUME(IREG)
                      ENDIF
 960                CONTINUE
 950              CONTINUE
 940            CONTINUE
C---
C TREAT SCAT(JGRC<-IGRC)
C---
               SCATTD(IMRG,JGRC,IGRC,IL)=SCATTD(IMRG,JGRC,IGRC,IL)
     >               +(DDIREC+DFRINT(IMRG,IGRC)*DINDIR)/DFINT(IMRG,IGRC)
 930          CONTINUE
 920        CONTINUE
 910      CONTINUE
        ENDIF
c$$$ 900   CONTINUE
      CALL SADPXS(IPEDIT,NAMSAV,NGCOND,NMERGE,MXNL  ,ITRANC,
     >            MNIFIS,NEDMAC,NTAUXT,NNAM  ,
     >            NAMEAD,NAME  ,INDICE,IXSFL  ,HVECT ,
     >            KEFFP,RATECM,SCATTD,RBASE(ISCATC) ,IBASE(IIJJ),
     >            IBASE(INJJ)  ,IBASE(IIPOS),RBASE(IFACT))
      CALL RLSARA(RBASE(IFACT))
      CALL RLSARA(IBASE(IIPOS))
      CALL RLSARA(IBASE(INJJ))
      CALL RLSARA(IBASE(IIJJ))
      CALL RLSARA(RBASE(ISCATC))
      RETURN
      END
